#include <stdlib.h>
#include <stdio.h>

struct posizione{
	int riga;
	int colonna;
};

struct posizione trovaPacman(char* T,int n,int m){
	struct posizione pos;
	int i;
	int j;	
	for(i = 0;i<n;i++){
		for(j=0;j<m;j++){
			if(T[i*m + j] == 'M'){
			pos.riga = i;
			pos.colonna = j;	
			return pos;			
			}
		}
	}
				
	pos.riga = -1;
	pos.colonna =-1;	
	return pos;
} 

struct posizione* trovaFantasmini(char* T,int n,int m,int k){
	int i;
	int j;
	int s;
	printf("\nn:%d\tm:%d\tk:%d\n",n,m,k);
	struct posizione *fantasmini = (struct posizione*)malloc(sizeof(struct posizione)*k);
	s=0;	
	/*printf("T3\n");
	for(i=0;i<n;i++){
		for(j=0;j<m;j++){
			printf("%c\t",T[i*m +j]);
		}
		
		printf("\n");
	}*/
	for(i = 0;i<n && s<k;i++){
		for(j=0;j<m && s<k;j++){			
			//printf("\ns:%d",s);
			if(T[i*m + j] == 'F'){
				fantasmini[s].riga = i;
				fantasmini[s].colonna = j;
				//printf("\nr:%d\tc:%d\n",fantasmini[s].riga,fantasmini[s].colonna);
				s++;
				}
		}
	}
	return fantasmini;

}
struct posizione* trovaPillolozzi(char* T,int n,int m,int p){
	int i;
	int j;
	int s;
	struct posizione *pillolozzi = (struct posizione*)malloc(sizeof(struct posizione)*p);
	s=0;//numero di pillolozzi trovati finora
	for(i = 0;i<n && s<p;i++){
		for(j=0;j<m && s<p;j++){			
			//printf("\np:%d",p);
			if(T[i*m + j] == 'P' ){
				pillolozzi[s].riga = i;
				pillolozzi[s].colonna = j;
				//printf("\nr:%d\tc:%d\n",pillolozzi[s].riga,pillolozzi[s].colonna);
				s++;
				}
		}
	}
	return pillolozzi;

}

int* distanza(struct posizione a,struct posizione* pillolozzi,int p){
	int *d = (int*)malloc(sizeof(int)*p);
	int i;
	int count;
	//uso una dfs per trovare la distanza
	for(i=0;i<p;i++){
		count =0;
		d[i] = count;			
	}

	return d;
}



 
//versione con numero di fantasmini e pillolozzi in input
int main(int argc,const char* argv[]){
char *T = NULL;
int i;
int j;
int k; //numero fantasmini
int n;
int m;
int p;
	FILE *file = fopen(argv[1],"r");
	fscanf(file,"%d\t",&n);
	fscanf(file,"%d\t",&m);
	fscanf(file,"%d\t",&k);
	fscanf(file,"%d\t",&p);
	T = (char*)malloc(sizeof(char)*n*m);
	char temp;
	i=0;
	//printf("T:\n",p);
	for(i=0;i<n;i++){
		for(j=0;j<m;j++){
			fscanf(file,"%c\t",&temp);
			T[i*m + j] = temp;
			//printf("%c\t",T[i*m +j]);
		}
		//i++;
		//printf("\n");
	}
	fclose(file);/*
	printf("T2\n");	
	for(i=0;i<n;i++){
		for(j=0;j<m;j++){
			printf("%c\t",T[i*m +j]);
		}
		printf("\n");
	}*/
	
	struct posizione *fantasmini = (struct posizione*)malloc(sizeof(struct posizione)*k);
	fantasmini = trovaFantasmini(T,n,m,k);
	printf("FANTASMINI");
	for(i=0;i<k;i++)
		printf("\nr:%d\tc:%d\n",fantasmini[i].riga,fantasmini[i].colonna);


	struct posizione *pillolozzi = (struct posizione*)malloc(sizeof(struct posizione)*p);
	pillolozzi = trovaPillolozzi(T,n,m,p);
	printf("PILLOLOZZI");
	for(i=0;i<p;i++)
		printf("\nr:%d\tc:%d\n",pillolozzi[i].riga,pillolozzi[i].colonna);

	struct posizione pacman = trovaPacman(T,n,m);
	printf("PACMAN:\n%d\t%d\n",pacman.riga,pacman.colonna);


	int *distanzaPacmanPillolozzi = (int*)malloc(sizeof(int)*p);
	distanzaPacmanPillolozzi = distanza(pacman,pillolozzi,p);
	
	int *distanzaFantasminiPillolozzi = (int*)malloc(sizeof(int)*k*p);
	/*for(i=0;i<k;i++)	
		distanzaFantasminiPillolozzi[i*p] = distanza(fantasmini[i],pillolozzi,p);	*/


	//free(pacman);
	//free(fantasmini);
	free(T);

}
